Hooks:PostHook(BlackMarketTweakData, "_init_melee_weapons", "ThisFileEditsMeleeStats", function(self) --replace "ThisFileEditsMeleeStats" with the name of this file.

--displayed stats

self.melee_weapons.melee weapon id.stats.min_damage = x --base damage without charging. multiplied by 10 in game.
self.melee_weapons.melee weapon id.stats.max_damage = x --full damage after changing. multiplied by 10 in game.
self.melee_weapons.melee weapon id.stats.min_damage_effect = x --knockdown without charging. base damage will be multiplied by this value in game.
self.melee_weapons.melee weapon id.stats.max_damage_effect = x --knockdown at full charge. full damage will be multiplied by this value in game.
self.melee_weapons.melee weapon id.stats.charge_time = x --time it takes to fully charge in seconds.
self.melee_weapons.melee weapon id.stats.range = x --range of the weapon. 100 is only about enough to hit what is directly in front of you.
self.melee_weapons.melee weapon id.stats.concealment = x --the concealment of the melee weapon.

--on hit effects

self.melee_weapons.melee weapon id.dot_data = {type = "poison", custom_data = {dot_length = 1, hurt_animation_chance = 0.7}} --this allows the melee weapon to apply the poison effect. 
self.melee_weapons.melee weapon id.special_weapon = "taser" --this allows the melee weapon to apply the taser stun effect.
self.melee_weapons.melee weapon id.fire_dot_data = { --this allows the melee weapon to set enemies on fire
		dot_trigger_chance = "20", --chance to ignite on hit
		dot_damage = "10", --damage dealt by the effect
		dot_length = "3.1", --lenght for which the damage is being dealt
		dot_trigger_max_distance = "3000", 
		dot_tick_period = "0.5" --the interval between when the damage is dealt. For example, if the tick period is set to 1 and dot lenght is set to 5, damage will be dealt each second for a total of 5 times
}

--timing and animations

self.melee_weapons.melee weapon id.repeat_expire_t = x --time between attacks in seconds
self.melee_weapons.melee weapon id.expire_t = x --unequip delay in seconds
self.melee_weapons.melee weapon id.melee_damage_delay = x --time between the press of the melee button and when the damage is dealt. for reference, for the katana the delay is 0.1 second, and for the fireaxe it's 0.6 seconds. this is completely separate from the actual animation.
self.melee_weapons.melee weapon id.anim_global_param = "x" --melee animation. many melee weapons share animations, but some of them have unique ones. list of all animations below. remember that the timing is separate from the animation.

--dot_lenght and hurt_animation_chance are the same for all vanilla posion melees. dot_lenght describes the amount of time for which the damage over time will last. 1 is equal to 0.5 seconds. poison deals 250 damage every 0.5 seconds.

--there are no other dot_data or special_weapon types. there is only poison, taser and fire.

--remember that the timing is separate from the animations. changing the animation will not change the delay between the button press and when damage is dealt. if you want to match the timing and the animation, go to https://github.com/mwSora/payday-2-luajit/blob/master/pd2-lua/lib/tweak_data/blackmarket/meleeweaponstweakdata.lua and search for the weapons that use the animation you want to use and copy the times.

--list of all melee animations: 
--generic: "melee_fist", "melee_knife", "melee_knife2", "melee_axe", "melee_baseballbat", "melee_stab", "melee_psycho", 
--unique: "melee_baseballbat_miami", "melee_cleaver", "melee_fireaxe", "melee_machete", "melee_briefcase",  "melee_freedom", "melee_boxing", "melee_blunt", "melee_pickaxe", "melee_taser", "melee_fight", "melee_twins", "melee_ballistic", "melee_agave", "melee_happy", "melee_grip", "melee_clean", "melee_great", "melee_hauteur", "melee_fear", "melee_chac", "melee_sandsteel", "melee_beardy", "melee_buck", "melee_cutters", "melee_boxcutter", "melee_pitchfork", "melee_nin", "melee_wing", "melee_road", "melee_cs", "melee_brick", "melee_ostry", "melee_catch". 

end ) --DO NOT REMOVE THIS LINE