Hooks:PostHook( WeaponTweakData, "init", "ThisFileEditsWeaponStats", function(self)  --replace "ThisFileEditsWeaponStats" with the name of this file

--[[

weapon ids can be found either at https://payday.fandom.com/wiki/Weapons_(Payday_2) on the specific weapons' sites or on https://wiki.modworkshop.net/books/payday-2/page/weapons in a big list all together

replace the entire "weapon id here" bit so that only the weapon id is between the dots (for example "self.glock_17.stats")

if you don't want to change a stat, do not leave an empty line, and remove it. an empty line without a proper weapon id or "x" instead of a number will cause crashes. any stat that isn't changed by the rebalance will simply stay the same as in the vanilla game

]]

--displayed stats

self.weapon id here.CLIP_AMMO_MAX = x --magazine size.
self.weapon id here.AMMO_MAX = x --total ammo.
self.weapon id here.fire_mode_data.fire_rate = 60 / x --firerate. Replace x with your desired firerate.
self.weapon id here.stats.damage = x --damage. the maximum vanilla value is 210. some weapons, however, mostly sniper rifles and explosives, have a damage multiplier that enables them to raise the damage above 210. remember to factor it in if you choose to rebalance these. additionally, changing this stat won't affect the actual damage dealt by explosives. in their case, the damage stat exists only for display, and the actual damage is handled by the projectile.
self.weapon id here.stats.spread = x --accuracy, gets multiplied by 4 and 4 is subtracted (for example 10 spread = 36 accuracy).
self.weapon id here.stats.recoil = x --stability, gets multiplied by 4 and 4 is subtracted (for example 10 recoil = 36 stability).
self.weapon id here.stats.suppression = x --threat, the distance on which enemies are suppressed by your gun, meaning they duck and jump for cover. 1 is the maximum value (43), 20 is the minimum value (0).
self.weapon id here.stats.concealment = x --concealment. The max value is 30, but it can be increased above that with attachments.
self.weapon id here.stats.reload = 11 --the time it takes the weapon to reload. 11 is the default value. values lower than 11 increase the reload time, down to the minimum value of 1 (doubled reload length). values above 11 decrease the reload time, up to a maximum value of 21 (halved reload length). full explanation at the bottom of the file.

--damage falloff

local FALLOFF_TEMPLATE = WeaponFalloffTemplate.setup_weapon_falloff_templates() --if you wish to change the damage falloff of more than one weapon, you don't need to copy this line. If you don't wish to change the damage falloff for any weapon, delete both this line and the one below.
self.weapon id here.damage_falloff = FALLOFF_TEMPLATE.x --replace the "x", and only the x, with the damage falloff template name. list of all the available falloff templates in the file number 3.

--hidden stats

self.weapon id here.stats_modifiers = {damage = x} --damage multiplier. used for sniper rifles and the displayed stat of explosives. the weapon damage as defined above will be modified by the value put in in place of x.
self.weapon id here.AMMO_PICKUP = {minimum, maximum} --ammo pickup is randomized between the two values.
self.weapon id here.can_shoot_through_enemy = x --true or false.
self.weapon id here.can_shoot_through_wall = x --true or false.
self.weapon id here.can_shoot_through_shield = x --true or false.
self.weapon id here.armor_piercing_chance = x --1 for always piercing, 0 for no piercing. can be any value inbetween for a chance of piercing.
self.weapon id here.stats.alert_size = x --the distance at which your gun shots are audible, matters only really in stealth. similarly to suppression, 1 is the maximum value, 20 is the minimum value (the gun is quiet as far as the game is concerned). distance table at the bottom of the file.

--shotgun exclusive stats

self.weapon id here.damage_near = x --the distance before any falloff is applied, measured in centimeters (100 = 1m). applies ONLY to shotguns. by default the value is 2000 for all shotguns.
self.weapon id here.damage_far = x --the distance from the point where falloff is applied to the point where the damage is no longer applied. for example, if damage_near is 300 and damage_far is 300, then after 3 meters the damage will start falling off, decreasing gradually with distance, and at 6 meters (300+300=600) the hits will no longer register. applies ONLY to shotguns. by default the value is 5000 for all shotguns.
self.weapon id here.rays = x --the amount of pellets shot from the gun. each pellet deals full damage, but only one (per enemy) can apply it - so more pellets don't mean more damage, but more chances to hit. applies ONLY to shotguns.

--advanced options, best not touch them unless you know what you're doing

self.weapon id here.categories = {"x"} --changes both the category the weapon is listed in, as well as the category to which skills apply. list of possible categories below.
self.weapon id here.use_data.selection_index = x --1 for secondary, 2 for primary.
self.weapon id here.FIRE_MODE = "x" --either auto or single.
self.weapon id here.CAN_TOGGLE_FIREMODE = x --either true or false.

self.weapon id here.weapon_hold = "x" --this changes the weapon's animation set. you might want to use it if you think a given weapon would look better with different animations, or if you decide to give a weapon a fire mode that it didn't previously have. weapons intended to fire in single only don't have animations for auto mode, so you might run into animation problems otherwise. adding automatic fire might result in either crashes or the weapon defaulting to wrong animations.

--weapons often reuse animation sets, and these sets aren't named after the id of the weapon that uses them. to find the name of the animation set you want to use, search weapontweakdata.

--when changing a weapon's animation set, the weapons viewmodel (its position on the screen) will shift as well. this may result in the gun not pointing to the middle of the screen to various degrees of inaccuracy when aiming. you can fix this with PVM, or by editing the weapons stance values - contact me for help with that. it's beyond the scope of this template on its own.

--automatic fire sounds for semi auto weapons

self.weapon id here.auto = {} --don't edit except for inserting the weapon id
self.weapon id here.auto.fire_rate = 0.00 --don't edit except for inserting the weapon id
self.weapon id here.sounds.fire_single = "x"
self.weapon id here.sounds.fire_auto = "x" --when adding auto fire to single-auto only guns, you might run into an issue where the weapon sounds don't play properly. this is because the weapon doesn't have dedicated auto fire sounds. to fix it, replace x with the id for the weapon's sounds, which should look like "id_fire". replace both the single and auto sound line with the sound id, and install Auto Fire Sound Fix to give the weapon proper auto fire sounds. to find the id for the weapon sounds you want to use, you must again search through weapontweakdata.

--kick. the kick values define what way the gun goes when recoiling. these values then get modified by the stability stat to be more or less severe.

self.weapon id here.kick.standing = {a, b, c, d} --a is vertical minimum, b is vertical maximum, c is horizontal right minimum, d is horizontal right maximum. Positive vertical values go up, negative values go down. Positive horizontal values go right, negative values go left. after a shot is fired, the game selects a random value between the two to move your camera.
self.weapon id here.kick.crouching = self.weapon id here.kick.standing --recoil when crouching
self.weapon id here.kick.steelsight = self.weapon id here.kick.standing --recoil when aiming down sights
--crouching and steelsight values can be changed independently of the standing kick values. by default, they are set to be the same.

--[[

shotgun exclusive stats only apply to shotguns. even if you change the weapon category, the exclusive stats still do not apply to that weapon.

list of categories: {"assault_rifle"}, {"shotgun"}, {"lmg"}, {"snp"}, {"akimbo", "pistol"}, {"akimbo", "smg"}, {"akimbo", "shotgun"}, {"wpn_special"}, {"pistol"}, {"smg"}. shotguns and specials can be both secondary and or primary. pistols and smgs can only be secondary.

if you add an auto mode to a weapon that doesn't have it, the weapon will use the car-4's animations due to the fact that single and auto fire use separate firing animations.

distance table for the alert_size stat:
1 = 300 meters
2 = 200m
3 = 150m
4 = 100m
5 = 75m
6 = 60m
7 = 45m
8 = 40m
9 = 35m
10 = 18m
11 = 15m
12 = 12m
13 = 10m
14 = 8.5m
15 = 7m
16 = 5m
17 = 3.5m
18 = 2m
19 = 1m
20 = 0m

reload stat explanation: you know it's good when an explanation starts with "because the devs are stupid". but,
because the devs are stupid, reload works in a weird way. it's split up into two things: the reload timers, which define how much time passes between the press of a button and the refilling of the magazine, and the animation lenght itself, which is not affected by timers. when Overkill introduced speedpull mags, and later decided to rebalance reload times as well, they added a third aspect that tied these two together: the reload stat. the reload stat takes the reload timers and the animation lenght and divides them both by the same value, so their speed can be changed. 11 corresponds to a value of 1, meaning both are divided by 1 and essentially unchanged. Values lower than 11 increment this divisor by 0.05, down to the value of 0.5 at 1. dividing by half is equal to multiplying by 2, so the reload time is doubled. values above 11 increment the divisor by 0.1, up to a value of 2 at 21. dividing by two halves the reload time. full table below, in case you want to be really precise with how you change the reload times.
1 = 0.5
2 = 0.55
3 = 0.6
4 = 0.65
5 = 0.7
6 = 0.75
7 = 0.8
8 = 0.85
9 = 0.9
10 = 0.95
11 = 1.0
12 = 1.1
13 = 1.2
14 = 1.3
15 = 1.4
16 = 1.5
17 = 1.6
18 = 1.7
19 = 1.8
20 = 1.9
21 = 2.0

]]

end ) --DO NOT REMOVE THIS LINE